#    most of this task is now taken from the standard application

set VERSION "MIDAS"

#    put some default environment variables before loading common 

if {[info exists env(RDOUThdwre)] == 0} then {set env(RDOUThdwre) VME} 

loadsource sys.common
loadsource GroupDefn

set frametitle "MIDAS Data Acquisition Experiment Control"

set VMEPresent 1
set VMEEnable 1

set TSEnable 1

set histEnable 1
set HistMode 1

set txEnable 1

set TestBuffer ""

lappend actionlist [list "Show histogram name translations" "Show_Xlate"]
lappend actionlist [list "Edit histogram translation file"  "edit_xlate"]


proc create_spectra {} {
   global SpectrumServer HistMode EGreport

   if {$HistMode == 0} {return}

   set-footer "Creating spectra"

   set EGreport_SAVE $EGreport
   set EGreport -1
   
   Make_Xlate $SpectrumServer

   set range 2048
   
   set z [catch {eg "(spectrum :path '/$SpectrumServer' :range $range :name 'Stat' !new)" } m]
   map_spectrum "Stat"

   set z [catch {eg "(spectrum :path '/$SpectrumServer' :range $range :name 'Rate' !new)" } m]

#   for silena 9418

    create_s9418_spectra
   
#    for CAEN V767

    create_v767_spectra

#    for CAEN V890

    create_v890_spectra
   
   set EGreport $EGreport_SAVE

   clear-footer
}

proc define_VME_addresses {} {

#    load hardware configuration into readout software

     ClearConfig

#    the S9418 VME modules

     define_s9418_config

#    the V767 VME modules

     define_v767_config

#    the V890 VME modules

     define_v890_config

#    then the acquisition control module

     define_sac_config
}

proc click-vme {action} {

   starttask vmecontrol

    switch $action {
      0    {set p DAQ-halt}
      1    {set p DAQ-go}
      2    {set p DAQ-reset}
      3    {set p DAQ-setup}
    }

   set-busy
 
   set-footer "sending $p to VME control task"
   set z [catch {send vmecontrol $p} m]

   clear-busy
   if {$m == ""} then {clear-footer} else {set-footer $m}

   if {$action == 3} then {
       define_VME_addresses
       if {[inform vmecontrol inquire v767count] > 0} then {loadsource v767.Setup}
       if {[inform vmecontrol inquire v890count] > 0} then {loadsource v890.Setup}
   }

   redisplay-vme
}

proc redisplay-vme {} {
    global VMEEnable vmestate

  if {$VMEEnable == 0} then {return}

   set vmestate [expr [read-register sac#1.Enable] & 1]
   :modify VME :value $vmestate
}

proc Stop_Electronics {} {

       write-register sac#1.STR 0
}

proc Go_Electronics {} {

    write-register sac#1.MON0 2
    write-register sac#1.STR 9
    write-register sac#1.ARM 0
}

proc Reset_Electronics {} {write-register sac#1.EVCLR 0}

